/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "api_services.v1";

export enum ExpireLevel {
  Forever = 0,
  Day = 1,
  Week = 2,
  Month = 3,
  Year = 4,
  UNRECOGNIZED = -1,
}

export function expireLevelFromJSON(object: any): ExpireLevel {
  switch (object) {
    case 0:
    case "Forever":
      return ExpireLevel.Forever;
    case 1:
    case "Day":
      return ExpireLevel.Day;
    case 2:
    case "Week":
      return ExpireLevel.Week;
    case 3:
    case "Month":
      return ExpireLevel.Month;
    case 4:
    case "Year":
      return ExpireLevel.Year;
    case -1:
    case "UNRECOGNIZED":
    default:
      return ExpireLevel.UNRECOGNIZED;
  }
}

export function expireLevelToJSON(object: ExpireLevel): string {
  switch (object) {
    case ExpireLevel.Forever:
      return "Forever";
    case ExpireLevel.Day:
      return "Day";
    case ExpireLevel.Week:
      return "Week";
    case ExpireLevel.Month:
      return "Month";
    case ExpireLevel.Year:
      return "Year";
    case ExpireLevel.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

export interface PastebinServiceRecord {
  /** 记录ID */
  id: number;
  /** 记录别名 */
  key: string;
  /** 记录标题 */
  title: string;
  /** 记录渲染后内容 */
  content: string;
  /** 记录创建时间 */
  created_at: string;
  /** 过期时间 */
  expired_at: string;
  /** 是否需要密码 */
  need_password: boolean;
  /** 是否可以修订 */
  editable: boolean;
  /** 指定记录有效期 */
  expire_level: ExpireLevel;
  /** 指定需要密码访问 */
  password: string;
  /** 指定语言 */
  lang: string;
  /** 作者 */
  author: string;
}

export interface PastebinServiceListReq {
  /** 分页大小 */
  page_size: number;
  /** 当前页 从第一页开始 */
  current_page: number;
}

export interface PastebinServiceListResp {
  /** 列表 */
  items: PastebinServiceRecord[];
  /** 是否有下一页 */
  has_more: boolean;
}

export interface PastebinServiceAddReq {
  record: PastebinServiceRecord | undefined;
}

export interface PastebinServiceAddResp {
}

export interface PastebinServiceUpdateReq {
  record: PastebinServiceRecord | undefined;
}

export interface PastebinServiceUpdateResp {
}

export interface PastebinServiceGetReq {
  key: string;
  password: string;
}

export interface PastebinServiceGetResp {
  record: PastebinServiceRecord | undefined;
}

export interface PastebinServiceRawReq {
  key: string;
  password: string;
}

export interface PastebinServiceRawResp {
}

function createBasePastebinServiceRecord(): PastebinServiceRecord {
  return {
    id: 0,
    key: "",
    title: "",
    content: "",
    created_at: "",
    expired_at: "",
    need_password: false,
    editable: false,
    expire_level: 0,
    password: "",
    lang: "",
    author: "",
  };
}

export const PastebinServiceRecord = {
  encode(message: PastebinServiceRecord, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== 0) {
      writer.uint32(8).int64(message.id);
    }
    if (message.key !== "") {
      writer.uint32(18).string(message.key);
    }
    if (message.title !== "") {
      writer.uint32(26).string(message.title);
    }
    if (message.content !== "") {
      writer.uint32(42).string(message.content);
    }
    if (message.created_at !== "") {
      writer.uint32(50).string(message.created_at);
    }
    if (message.expired_at !== "") {
      writer.uint32(58).string(message.expired_at);
    }
    if (message.need_password === true) {
      writer.uint32(64).bool(message.need_password);
    }
    if (message.editable === true) {
      writer.uint32(72).bool(message.editable);
    }
    if (message.expire_level !== 0) {
      writer.uint32(80).int32(message.expire_level);
    }
    if (message.password !== "") {
      writer.uint32(90).string(message.password);
    }
    if (message.lang !== "") {
      writer.uint32(98).string(message.lang);
    }
    if (message.author !== "") {
      writer.uint32(106).string(message.author);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceRecord {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.id = longToNumber(reader.int64() as Long);
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.key = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.title = reader.string();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.content = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.created_at = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.expired_at = reader.string();
          continue;
        case 8:
          if (tag !== 64) {
            break;
          }

          message.need_password = reader.bool();
          continue;
        case 9:
          if (tag !== 72) {
            break;
          }

          message.editable = reader.bool();
          continue;
        case 10:
          if (tag !== 80) {
            break;
          }

          message.expire_level = reader.int32() as any;
          continue;
        case 11:
          if (tag !== 90) {
            break;
          }

          message.password = reader.string();
          continue;
        case 12:
          if (tag !== 98) {
            break;
          }

          message.lang = reader.string();
          continue;
        case 13:
          if (tag !== 106) {
            break;
          }

          message.author = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceRecord {
    return {
      id: isSet(object.id) ? globalThis.Number(object.id) : 0,
      key: isSet(object.key) ? globalThis.String(object.key) : "",
      title: isSet(object.title) ? globalThis.String(object.title) : "",
      content: isSet(object.content) ? globalThis.String(object.content) : "",
      created_at: isSet(object.createdAt) ? globalThis.String(object.createdAt) : "",
      expired_at: isSet(object.expiredAt) ? globalThis.String(object.expiredAt) : "",
      need_password: isSet(object.needPassword) ? globalThis.Boolean(object.needPassword) : false,
      editable: isSet(object.editable) ? globalThis.Boolean(object.editable) : false,
      expire_level: isSet(object.expireLevel) ? expireLevelFromJSON(object.expireLevel) : 0,
      password: isSet(object.password) ? globalThis.String(object.password) : "",
      lang: isSet(object.lang) ? globalThis.String(object.lang) : "",
      author: isSet(object.author) ? globalThis.String(object.author) : "",
    };
  },

  toJSON(message: PastebinServiceRecord): unknown {
    const obj: any = {};
    if (message.id !== 0) {
      obj.id = Math.round(message.id);
    }
    if (message.key !== "") {
      obj.key = message.key;
    }
    if (message.title !== "") {
      obj.title = message.title;
    }
    if (message.content !== "") {
      obj.content = message.content;
    }
    if (message.created_at !== "") {
      obj.createdAt = message.created_at;
    }
    if (message.expired_at !== "") {
      obj.expiredAt = message.expired_at;
    }
    if (message.need_password === true) {
      obj.needPassword = message.need_password;
    }
    if (message.editable === true) {
      obj.editable = message.editable;
    }
    if (message.expire_level !== 0) {
      obj.expireLevel = expireLevelToJSON(message.expire_level);
    }
    if (message.password !== "") {
      obj.password = message.password;
    }
    if (message.lang !== "") {
      obj.lang = message.lang;
    }
    if (message.author !== "") {
      obj.author = message.author;
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceRecord>, I>>(base?: I): PastebinServiceRecord {
    return PastebinServiceRecord.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceRecord>, I>>(object: I): PastebinServiceRecord {
    const message = createBasePastebinServiceRecord();
    message.id = object.id ?? 0;
    message.key = object.key ?? "";
    message.title = object.title ?? "";
    message.content = object.content ?? "";
    message.created_at = object.created_at ?? "";
    message.expired_at = object.expired_at ?? "";
    message.need_password = object.need_password ?? false;
    message.editable = object.editable ?? false;
    message.expire_level = object.expire_level ?? 0;
    message.password = object.password ?? "";
    message.lang = object.lang ?? "";
    message.author = object.author ?? "";
    return message;
  },
};

function createBasePastebinServiceListReq(): PastebinServiceListReq {
  return { page_size: 0, current_page: 0 };
}

export const PastebinServiceListReq = {
  encode(message: PastebinServiceListReq, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.page_size !== 0) {
      writer.uint32(8).int64(message.page_size);
    }
    if (message.current_page !== 0) {
      writer.uint32(16).int64(message.current_page);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceListReq {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceListReq();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.page_size = longToNumber(reader.int64() as Long);
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.current_page = longToNumber(reader.int64() as Long);
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceListReq {
    return {
      page_size: isSet(object.pageSize) ? globalThis.Number(object.pageSize) : 0,
      current_page: isSet(object.currentPage) ? globalThis.Number(object.currentPage) : 0,
    };
  },

  toJSON(message: PastebinServiceListReq): unknown {
    const obj: any = {};
    if (message.page_size !== 0) {
      obj.pageSize = Math.round(message.page_size);
    }
    if (message.current_page !== 0) {
      obj.currentPage = Math.round(message.current_page);
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceListReq>, I>>(base?: I): PastebinServiceListReq {
    return PastebinServiceListReq.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceListReq>, I>>(object: I): PastebinServiceListReq {
    const message = createBasePastebinServiceListReq();
    message.page_size = object.page_size ?? 0;
    message.current_page = object.current_page ?? 0;
    return message;
  },
};

function createBasePastebinServiceListResp(): PastebinServiceListResp {
  return { items: [], has_more: false };
}

export const PastebinServiceListResp = {
  encode(message: PastebinServiceListResp, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.items) {
      PastebinServiceRecord.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.has_more === true) {
      writer.uint32(16).bool(message.has_more);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceListResp {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceListResp();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.items.push(PastebinServiceRecord.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.has_more = reader.bool();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceListResp {
    return {
      items: globalThis.Array.isArray(object?.items)
        ? object.items.map((e: any) => PastebinServiceRecord.fromJSON(e))
        : [],
      has_more: isSet(object.hasMore) ? globalThis.Boolean(object.hasMore) : false,
    };
  },

  toJSON(message: PastebinServiceListResp): unknown {
    const obj: any = {};
    if (message.items?.length) {
      obj.items = message.items.map((e) => PastebinServiceRecord.toJSON(e));
    }
    if (message.has_more === true) {
      obj.hasMore = message.has_more;
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceListResp>, I>>(base?: I): PastebinServiceListResp {
    return PastebinServiceListResp.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceListResp>, I>>(object: I): PastebinServiceListResp {
    const message = createBasePastebinServiceListResp();
    message.items = object.items?.map((e) => PastebinServiceRecord.fromPartial(e)) || [];
    message.has_more = object.has_more ?? false;
    return message;
  },
};

function createBasePastebinServiceAddReq(): PastebinServiceAddReq {
  return { record: undefined };
}

export const PastebinServiceAddReq = {
  encode(message: PastebinServiceAddReq, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.record !== undefined) {
      PastebinServiceRecord.encode(message.record, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceAddReq {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceAddReq();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.record = PastebinServiceRecord.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceAddReq {
    return { record: isSet(object.record) ? PastebinServiceRecord.fromJSON(object.record) : undefined };
  },

  toJSON(message: PastebinServiceAddReq): unknown {
    const obj: any = {};
    if (message.record !== undefined) {
      obj.record = PastebinServiceRecord.toJSON(message.record);
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceAddReq>, I>>(base?: I): PastebinServiceAddReq {
    return PastebinServiceAddReq.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceAddReq>, I>>(object: I): PastebinServiceAddReq {
    const message = createBasePastebinServiceAddReq();
    message.record = (object.record !== undefined && object.record !== null)
      ? PastebinServiceRecord.fromPartial(object.record)
      : undefined;
    return message;
  },
};

function createBasePastebinServiceAddResp(): PastebinServiceAddResp {
  return {};
}

export const PastebinServiceAddResp = {
  encode(_: PastebinServiceAddResp, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceAddResp {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceAddResp();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): PastebinServiceAddResp {
    return {};
  },

  toJSON(_: PastebinServiceAddResp): unknown {
    const obj: any = {};
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceAddResp>, I>>(base?: I): PastebinServiceAddResp {
    return PastebinServiceAddResp.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceAddResp>, I>>(_: I): PastebinServiceAddResp {
    const message = createBasePastebinServiceAddResp();
    return message;
  },
};

function createBasePastebinServiceUpdateReq(): PastebinServiceUpdateReq {
  return { record: undefined };
}

export const PastebinServiceUpdateReq = {
  encode(message: PastebinServiceUpdateReq, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.record !== undefined) {
      PastebinServiceRecord.encode(message.record, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceUpdateReq {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceUpdateReq();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.record = PastebinServiceRecord.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceUpdateReq {
    return { record: isSet(object.record) ? PastebinServiceRecord.fromJSON(object.record) : undefined };
  },

  toJSON(message: PastebinServiceUpdateReq): unknown {
    const obj: any = {};
    if (message.record !== undefined) {
      obj.record = PastebinServiceRecord.toJSON(message.record);
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceUpdateReq>, I>>(base?: I): PastebinServiceUpdateReq {
    return PastebinServiceUpdateReq.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceUpdateReq>, I>>(object: I): PastebinServiceUpdateReq {
    const message = createBasePastebinServiceUpdateReq();
    message.record = (object.record !== undefined && object.record !== null)
      ? PastebinServiceRecord.fromPartial(object.record)
      : undefined;
    return message;
  },
};

function createBasePastebinServiceUpdateResp(): PastebinServiceUpdateResp {
  return {};
}

export const PastebinServiceUpdateResp = {
  encode(_: PastebinServiceUpdateResp, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceUpdateResp {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceUpdateResp();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): PastebinServiceUpdateResp {
    return {};
  },

  toJSON(_: PastebinServiceUpdateResp): unknown {
    const obj: any = {};
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceUpdateResp>, I>>(base?: I): PastebinServiceUpdateResp {
    return PastebinServiceUpdateResp.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceUpdateResp>, I>>(_: I): PastebinServiceUpdateResp {
    const message = createBasePastebinServiceUpdateResp();
    return message;
  },
};

function createBasePastebinServiceGetReq(): PastebinServiceGetReq {
  return { key: "", password: "" };
}

export const PastebinServiceGetReq = {
  encode(message: PastebinServiceGetReq, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.password !== "") {
      writer.uint32(18).string(message.password);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceGetReq {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceGetReq();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.key = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.password = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceGetReq {
    return {
      key: isSet(object.key) ? globalThis.String(object.key) : "",
      password: isSet(object.password) ? globalThis.String(object.password) : "",
    };
  },

  toJSON(message: PastebinServiceGetReq): unknown {
    const obj: any = {};
    if (message.key !== "") {
      obj.key = message.key;
    }
    if (message.password !== "") {
      obj.password = message.password;
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceGetReq>, I>>(base?: I): PastebinServiceGetReq {
    return PastebinServiceGetReq.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceGetReq>, I>>(object: I): PastebinServiceGetReq {
    const message = createBasePastebinServiceGetReq();
    message.key = object.key ?? "";
    message.password = object.password ?? "";
    return message;
  },
};

function createBasePastebinServiceGetResp(): PastebinServiceGetResp {
  return { record: undefined };
}

export const PastebinServiceGetResp = {
  encode(message: PastebinServiceGetResp, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.record !== undefined) {
      PastebinServiceRecord.encode(message.record, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceGetResp {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceGetResp();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.record = PastebinServiceRecord.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceGetResp {
    return { record: isSet(object.record) ? PastebinServiceRecord.fromJSON(object.record) : undefined };
  },

  toJSON(message: PastebinServiceGetResp): unknown {
    const obj: any = {};
    if (message.record !== undefined) {
      obj.record = PastebinServiceRecord.toJSON(message.record);
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceGetResp>, I>>(base?: I): PastebinServiceGetResp {
    return PastebinServiceGetResp.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceGetResp>, I>>(object: I): PastebinServiceGetResp {
    const message = createBasePastebinServiceGetResp();
    message.record = (object.record !== undefined && object.record !== null)
      ? PastebinServiceRecord.fromPartial(object.record)
      : undefined;
    return message;
  },
};

function createBasePastebinServiceRawReq(): PastebinServiceRawReq {
  return { key: "", password: "" };
}

export const PastebinServiceRawReq = {
  encode(message: PastebinServiceRawReq, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.password !== "") {
      writer.uint32(18).string(message.password);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceRawReq {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceRawReq();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.key = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.password = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PastebinServiceRawReq {
    return {
      key: isSet(object.key) ? globalThis.String(object.key) : "",
      password: isSet(object.password) ? globalThis.String(object.password) : "",
    };
  },

  toJSON(message: PastebinServiceRawReq): unknown {
    const obj: any = {};
    if (message.key !== "") {
      obj.key = message.key;
    }
    if (message.password !== "") {
      obj.password = message.password;
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceRawReq>, I>>(base?: I): PastebinServiceRawReq {
    return PastebinServiceRawReq.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceRawReq>, I>>(object: I): PastebinServiceRawReq {
    const message = createBasePastebinServiceRawReq();
    message.key = object.key ?? "";
    message.password = object.password ?? "";
    return message;
  },
};

function createBasePastebinServiceRawResp(): PastebinServiceRawResp {
  return {};
}

export const PastebinServiceRawResp = {
  encode(_: PastebinServiceRawResp, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PastebinServiceRawResp {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePastebinServiceRawResp();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): PastebinServiceRawResp {
    return {};
  },

  toJSON(_: PastebinServiceRawResp): unknown {
    const obj: any = {};
    return obj;
  },

  create<I extends Exact<DeepPartial<PastebinServiceRawResp>, I>>(base?: I): PastebinServiceRawResp {
    return PastebinServiceRawResp.fromPartial(base ?? ({} as any));
  },
  fromPartial<I extends Exact<DeepPartial<PastebinServiceRawResp>, I>>(_: I): PastebinServiceRawResp {
    const message = createBasePastebinServiceRawResp();
    return message;
  },
};

/**
 * @route_group: true
 * @base_url: /v1/pastebin
 * @gen_to: ./services/controller/v1/pastebin_controller.go
 */
export interface PastebinService {
  /**
   * @desc: 列表
   * @author: Young Xu
   * @method: GET
   * @api: /list
   */
  List(request: PastebinServiceListReq): Promise<PastebinServiceListResp>;
  /**
   * @desc: 新建
   * @author: Young Xu
   * @method: PUT
   * @api: /add
   */
  Add(request: PastebinServiceAddReq): Promise<PastebinServiceAddResp>;
  /**
   * @desc: 更新
   * @author: Young Xu
   * @method: POST
   * @api: /update
   */
  Update(request: PastebinServiceUpdateReq): Promise<PastebinServiceUpdateResp>;
  /**
   * @desc: 获取一条记录
   * @author: Young Xu
   * @method: GET
   * @api: /get
   */
  Get(request: PastebinServiceGetReq): Promise<PastebinServiceGetResp>;
  /**
   * @desc: 获取原文内容
   * @author: Young Xu
   * @method: GET
   * @api: /raw
   */
  Raw(request: PastebinServiceRawReq): Promise<PastebinServiceRawResp>;
}

export const PastebinServiceServiceName = "api_services.v1.PastebinService";
export class PastebinServiceClientImpl implements PastebinService {
  private readonly rpc: Rpc;
  private readonly service: string;
  constructor(rpc: Rpc, opts?: { service?: string }) {
    this.service = opts?.service || PastebinServiceServiceName;
    this.rpc = rpc;
    this.List = this.List.bind(this);
    this.Add = this.Add.bind(this);
    this.Update = this.Update.bind(this);
    this.Get = this.Get.bind(this);
    this.Raw = this.Raw.bind(this);
  }
  List(request: PastebinServiceListReq): Promise<PastebinServiceListResp> {
    const data = PastebinServiceListReq.encode(request).finish();
    const promise = this.rpc.request(this.service, "List", data);
    return promise.then((data) => PastebinServiceListResp.decode(_m0.Reader.create(data)));
  }

  Add(request: PastebinServiceAddReq): Promise<PastebinServiceAddResp> {
    const data = PastebinServiceAddReq.encode(request).finish();
    const promise = this.rpc.request(this.service, "Add", data);
    return promise.then((data) => PastebinServiceAddResp.decode(_m0.Reader.create(data)));
  }

  Update(request: PastebinServiceUpdateReq): Promise<PastebinServiceUpdateResp> {
    const data = PastebinServiceUpdateReq.encode(request).finish();
    const promise = this.rpc.request(this.service, "Update", data);
    return promise.then((data) => PastebinServiceUpdateResp.decode(_m0.Reader.create(data)));
  }

  Get(request: PastebinServiceGetReq): Promise<PastebinServiceGetResp> {
    const data = PastebinServiceGetReq.encode(request).finish();
    const promise = this.rpc.request(this.service, "Get", data);
    return promise.then((data) => PastebinServiceGetResp.decode(_m0.Reader.create(data)));
  }

  Raw(request: PastebinServiceRawReq): Promise<PastebinServiceRawResp> {
    const data = PastebinServiceRawReq.encode(request).finish();
    const promise = this.rpc.request(this.service, "Raw", data);
    return promise.then((data) => PastebinServiceRawResp.decode(_m0.Reader.create(data)));
  }
}

interface Rpc {
  request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & { [K in Exclude<keyof I, KeysOfUnion<P>>]: never };

function longToNumber(long: Long): number {
  if (long.gt(globalThis.Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
