import './assets/base.css'

import { createApp } from 'vue'
import { createPinia } from 'pinia'

import App from './App.vue'
import router from './router'
import Notifications from '@kyvg/vue3-notification'
import VueHighlightJS from 'vue3-highlightjs'
import 'vue3-highlightjs/styles/gruvbox-dark.css'

const app = createApp(App)

app.use(createPinia())
app.use(router)
app.use(Notifications)
app.use(VueHighlightJS)

app.mount('#app')
