import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import * as path from "path";

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue(),
  ],
  resolve: {
    alias: {
      '@views': path.resolve(__dirname, "./src/views"),
      '@request': path.resolve(__dirname, "./src/request"),
      '@stores': path.resolve(__dirname, "./src/stores"),
      '@gen': path.resolve(__dirname, "./src/gen"),
    }
  }
})
